package com.vaartatechnologies.flutter_sound_system.includes;

import android.media.MediaPlayer;
import android.media.MediaRecorder;

import java.io.IOException;

public class RecordingHelper {

    private static MediaRecorder mediaRecorder;
    private static MediaPlayer mediaPlayer;
    private static String audioFilePath = "";
    private static boolean recording = false;
    private static boolean playing = false;

    public static Boolean isRecording(){
        return recording;
    }

    public static void startRecording(String audioFileNamedPath){
        if(!recording){
            recording = true;

            audioFilePath = audioFileNamedPath;

            mediaRecorder = new MediaRecorder();
            mediaRecorder.setAudioSource(MediaRecorder.AudioSource.MIC);
            mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
            mediaRecorder.setOutputFile(audioFilePath);
            mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);

            try{
                mediaRecorder.prepare();
                mediaRecorder.start();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static String stopRecording(){
        if(recording){
            recording = false;
            try{
                mediaRecorder.stop();
                mediaRecorder.release();
                mediaRecorder = null;
            } catch (RuntimeException stopException) {
                stopException.printStackTrace();
                audioFilePath = "";
            }
            return audioFilePath;
        }

        return "";
    }

    public static Boolean isPlaying(){
        return playing;
    }

    public static void play(String file){
        if(!playing){
            mediaPlayer = new MediaPlayer();
            try{
                mediaPlayer.setDataSource(file);
                mediaPlayer.prepare();
                mediaPlayer.start();
                playing = true;

                mediaPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
                    @Override
                    public void onCompletion(MediaPlayer mp) {
                    }
                });
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static void pausePlaying(){
        if(playing){
            mediaPlayer.pause();
            playing = false;
        }
    }

    public static void stopPlaying(){
        if(playing){
            mediaPlayer.stop();
            playing = false;
        }
    }
}