
import 'dart:async';

import 'package:flutter/services.dart';

class FlutterSoundSystem {
  static const MethodChannel _channel = MethodChannel('flutter_sound_system');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<bool> isRecording() async {
    return await _channel.invokeMethod('isRecording');
  }

  static void record(String audioFileNamedPath) {
    _channel.invokeMethod('record');
  }

  static Future<String> stopRecording() async {
    return await _channel.invokeMethod('stopRecording');
  }

  static Future<bool> isPlaying() async {
    return await _channel.invokeMethod('isPlaying');
  }

  static void play(String audioFileNamedPath) {
    _channel.invokeMethod('play');
  }

  static void pausePlaying() {
    _channel.invokeMethod('pausePlaying');
  }

  static void stopPlaying() {
    _channel.invokeMethod('stopPlaying');
  }
}